module cpolydiv 
  ! complex Helix polynomial division
  use cadj_mod
  use chelix
  implicit none
  type (cfilter), private :: aa
contains
  subroutine cpolydiv_init ( aa_in)
    type (cfilter) :: aa_in
    aa=aa_in
  end subroutine cpolydiv_init

  function cpolydiv_clop (adj,add, yy,xx) result (stat)
    logical, intent(in)     :: adj,add 
    complex, dimension(:) :: xx,yy 
    integer stat
    integer  ia, ix, iy
    complex  t

    if(adj) then
       if (.not.add) yy=0.
       do ix=size(xx),1,-1
          t = xx(ix)
          do ia = 2, size(aa%lag)
             iy = ix + aa%lag(ia)
             if (iy > size(yy)) cycle
             t = t - yy(iy) * conjg(aa%flt(ia))
          end do
          yy(ix) = yy(ix) + t/conjg(aa%flt(1))
       end do
    else
       if (.not.add) xx=0.
       do iy=1,size(yy)
          t = yy(iy)
          do ia=2, size(aa%lag)
             ix = iy - aa%lag(ia)
             if (ix < 1) cycle
             t = t - xx(ix) * aa%flt(ia)
          end do
          xx(iy) = xx(iy) + t/aa%flt(1)
       end do
    end if

    stat=0
  end function cpolydiv_clop
end module cpolydiv
