! Spectral factorization.
subroutine crosskolmog( n, cx1, cx2)

	integer i, n			! input:  cx1 = spectrum
	complex cx1(n),cx2(n)	! output: cx1, cx2 = 2 min phase causal wavelet
							! such that spectrum = cx2' * cx1

	!call zero(n,cx2(n/2+1))
	do i= 1, n
        cx1(i) = clog( cx1(i) )
	end do

	! go to time domain
	call ftu( -1., n, cx1)
	call scaleit( sqrt(1./n), 2*n, cx1)

	cx1(1    )=cx1(1    )/2.
	cx2(1    )=cx1(1    )
	cx1(1+n/2)=cx1(1+n/2)/2.
	cx2(1+n/2)=cx1(1+n/2)

	do i= n/2 + 2, n
		cx2(n-i+2) = cx1(i)
		cx1(i)=0.
		cx2(i)=0.
	end do
	 
	! go to frequency domain
	call ftu( +1., n, cx1)
	call scaleit( sqrt(1.*n), 2*n, cx1)

	call ftu( +1., n, cx2)
	call scaleit( sqrt(1.*n), 2*n, cx2)

	do i=1, n
	        cx1(i) = cexp( cx1(i))
	        cx2(i) = cexp( cx2(i))
	end do
	
	! back to time to finish
	call ftu( -1., n, cx1)
	call scaleit( sqrt(1./n), 2*n, cx1)

	call ftu( -1., n, cx2)
	call scaleit( sqrt(1./n), 2*n, cx2)

	do i=1, n
		cx2(i) = conjg(cx2(i))
	end do

	return
end subroutine
