% dispersion relation for 1D implicit FD vs. explicit
echo off;
clear;
clc;

nx	= 100;
dx  = 10;
v   = 1000;
dt  = 0.001;

v2  = v^2;
dx2 = dx^2;
dt2 = dt^2;

k		= pi/(nx*dx) : pi/(nx*dx) : pi/(2*dx);
kdx		= k * dx;
alpha	= v2 / (3*dx2);
alphat	= alpha * dt2;
alphaexp = v * dt / dx
sink	= sin(kdx ./ 2);

kabs	= abs(k);
my_asin	= asin ( sqrt(3*alphat) .* sink ./ sqrt (1 + 4 .*alphat .* (sink).^2 ))
Vp		= 2 .* my_asin ./ (dt .* kabs)
Vpexp	= 2 .* asin ( alphaexp .* sin (0.5 .* kdx) ) ./ (dt .* kabs);

figure;
plot (kdx,Vp/v, 'b'), xlabel('k*dx (rad)'), ylabel('Vphase / V');
hold;
plot (kdx,Vpexp/v, 'r');
legend('Implicit 1D', 'Explicit 1D');
title('dispersion relation normalized by medium velocity');


%for i = 1:size(k(:))
%	for j = 1:size(k(:))
%		cuscus = ( cosk(i) + cosk(j) );
%		numer = 1 - 2 * alpha * dt2 + 0.5 * alpha * dt2 * cuscus;
%		denom = 1 + 4 * alpha * dt2 + alpha * dt2 * cuscus;
%		kabs  = sqrt ( k(i)^2 + k(j)^2 );
%		Vp (i,j) = 1.0 / (dt * kabs * v) * acos (numer / denom);
%	end
%end
%figure
%surf (k,k,Vp)
