! Convolution, inverse to deconvolution.
module ohelicon  

	use adj_mod
	use helix		! Requires the filter be causal with an implicit "1." at the onset.
	implicit none

	integer, private		:: nd 
	type (filter), private	:: aa, aa_inv 

 contains

	subroutine ohelicon_init (aa_in, aa_inv_in)
		type (filter)	:: aa_in, aa_inv_in

		aa = aa_in
		aa_inv = aa_inv_in
	end subroutine

	function ohelicon_lop (adj, add, xx, yy) result (stat)
		integer					:: stat 
		logical, intent(in)		:: adj,add 
		real, dimension(:)		:: xx,yy 

		call adjnull		(adj, add, xx, yy)
		call ohelicon_lop2	(adj, add, xx, yy)

		stat = 0
	end function 

	subroutine ohelicon_lop2 (adj, add, xx, yy)
		logical, intent (in)	:: adj,add 
		real, dimension (:)		:: xx, yy
		integer 				:: iy, ix, ia

		do ia = 1, size (aa%lag)
			do iy = 1 + aa%lag (ia), size(yy)

				if ( associated (aa%mis)) then
					if (aa%mis (iy)) then
						cycle
					end if
				end if
 
				ix = iy - aa%lag (ia)

				if ( adj) then
					xx(ix) = xx (ix) + yy (iy) * aa_inv%flt (ia)
				else
					yy(iy) = yy (iy) + xx (ix) * aa%flt (ia)
				end if

			end do
		end do
	end subroutine 

	subroutine ohelicon_close()
	end subroutine 

end module 
