program specfac_kol
	use sep
	use prop2dutils

	implicit none

	integer, external	:: sreed, srite
	integer				:: i, j, k, s, jjj
	real				:: tt, dx, dz, ox, oz, dt, ot, eps, oeps, deps, m_pi
	real				:: idx, idz, idx2, idz2, dt2
	real				:: printdt, srcmaxt, vmax, vavg, big_dt, cvel, cvel2, impnorm, expnorm, fmax
	integer				:: nx, nz, nt, neps, srcx, srcz, nsnaps, pint, nx_norm
	integer				:: stat, ncoeffs
	type(cfilter)		:: impfilt
	complex, pointer, dimension(:) :: ccfilt

	real								:: a_t3, b_t3, c_t3

	m_pi = 2 * acos(0.)

	!#######################
	! get input parameters
	!#######################
	call initpar()

	call from_param ("nz", nz)
	call from_param ("dz", dz)
	call from_param ("oz", oz)
	call from_param ("nx", nx)
	call from_param ("dx", dx)
	call from_param ("ox", ox)

	call from_param ("nt", nt)
	call from_param ("dt", dt)
	call from_param ("ot", ot)
	call from_param ("ncoeffs", ncoeffs)
	call from_param ("oeps", oeps)
	call from_param ("neps", neps)
	call from_param ("deps", deps)
	call from_param ("cvel", cvel)

	!########################
	! initializations
	!########################

	srcx	= nx / 2
	srcz	= nz / 2
	idx		= 1. / dx
	idz		= 1. / dz
	idx2	= idx * idx
	idz2	= idz * idz
	cvel2	= cvel * cvel

	! save modelling parameters
	call to_history ("n1", ncoeffs*4)
	call to_history ("d1", 1)
	call to_history ("o1", 1)
	call to_history ("label1", "coeffs")
	call to_history ("n2", nt-1)
	call to_history ("d2", dt)
	call to_history ("o2", ot)
	call to_history ("label2", "dt")
	call to_history ("n3", neps)
	call to_history ("d3", deps)
	call to_history ("o3", oeps)
	call to_history ("label3", "eps")
	call to_history ("esize", "8")
	
	! 4th spatial order FD weights

	tt = 0.01
	dt2 = tt * tt
	a_t3	=  cvel2 * dt2 * idx2 / (4. * 12.)
	b_t3	=  -16. * a_t3
	c_t3	=  1. + 2. * 30. * a_t3

	impfilt = impfackol4 (eps, c_t3, b_t3, b_t3, a_t3, a_t3, nz, ncoeffs)

write (0,*), "size of impfilt:", size(impfilt%flt)
write (0,*), "max lag of impfilt:", maxval(impfilt%lag)



	allocate (ccfilt (size(impfilt%flt)))
	call ccorrelate (impfilt%flt, impfilt%flt, ccfilt, size (impfilt%flt))

	if (srite ("out", impfilt%flt, size(impfilt%flt) * sizeof (impfilt%flt(1))) .eq. 0) call seperr ("error writing filter coefficients")
	if (srite ("out", ccfilt, size(ccfilt) * sizeof (ccfilt(1))) .eq. 0) call seperr ("error writing filter coefficients")



call exit()



	do eps = oeps, oeps + neps * deps, deps

		do tt = ot + dt, ot + dt * nt, dt
			dt2 = tt * tt

			! 4th spatial order FD weights
			a_t3	=  cvel2 * dt2 * idx2 / (4. * 12.)
			b_t3	=  -16. * a_t3
			c_t3	=  1. + 2. * 30. * a_t3

			impfilt = impfackol4 (eps, c_t3, b_t3, b_t3, a_t3, a_t3, nz, ncoeffs)
	
			if (srite ("out", impfilt%flt, size(impfilt%flt) * sizeof (impfilt%flt(1))) .eq. 0) call seperr ("error writing filter coefficients")

		end do

	end do

end program
